# -*- coding: utf-8 -*-
from math import atan,cos,sin,pi
import Image
import os

liste_fichier_tous = os.listdir('.')
liste_fichier_couleur = []
for fichier in liste_fichier_tous:
    # le nom de mes fichiers photo commence par 'CI'
    if fichier[0]+fichier[1] == 'CI': liste_fichier_couleur.append(fichier)
liste_fichier_couleur.sort()

liste_fichier = []
for fichier in liste_fichier_tous:
    if fichier[0]+fichier[1] == 'nb': liste_fichier.append(fichier)
liste_fichier.sort()
#print liste_fichier
    
liste_centre = []
liste_haut = []

print 'rectangle du centre'
print 'coin haut gauche'
coin_haut_gauche_x = input('x ? ')
coin_haut_gauche_y = input('y ? ')
print 'coin bas droite'
coin_bas_droite_x = input('x ? ')
coin_bas_droite_y = input('y ? ')
print 'rectangle du haut'
print 'coin haut gauche'
haut_haut_gauche_x = input('x ? ')
haut_haut_gauche_y = input('y ? ')
print 'coin bas droite'
haut_bas_droite_x = input('x ? ')
haut_bas_droite_y = input('y ? ')

for fichier in liste_fichier:
    image = Image.open(fichier)
    image_centre = image.crop((coin_haut_gauche_x,coin_haut_gauche_y,coin_bas_droite_x,coin_bas_droite_y))
    image_haut = image.crop((haut_haut_gauche_x,haut_haut_gauche_y,haut_bas_droite_x,haut_bas_droite_y))
    image = 4
    image_centre_data = list(image_centre.getdata())
    image_haut_data = list(image_haut.getdata())
    image_centre = 4
    image_haut = 4

    i = image_centre_data.index(max(image_centre_data))
    largeur = coin_bas_droite_x-coin_haut_gauche_x
    x_max = i%largeur
    y_max = i/largeur
    x_centre = 0
    y_centre = 0
    somme = 0
    for i in range(x_max-5,x_max+6):
        for j in range(y_max-5,y_max+6):
            x_centre = x_centre + i*image_centre_data[i+largeur*j]
            y_centre = y_centre + j*image_centre_data[i+largeur*j]
            somme = somme + image_centre_data[i+largeur*j]
    x_centre = 1.0*x_centre/somme
    y_centre = 1.0*y_centre/somme
    centre = [coin_haut_gauche_x + x_centre, coin_haut_gauche_y + y_centre]
    #print centre
    liste_centre.append(centre)
    
    i = image_haut_data.index(max(image_haut_data))
    largeur = haut_bas_droite_x-haut_haut_gauche_x
    x_max = i%largeur
    y_max = i/largeur
    x_centre = 0
    y_centre = 0
    somme = 0
    for i in range(x_max-5,x_max+6):
        for j in range(y_max-5,y_max+6):
            x_centre = x_centre + i*image_haut_data[i+largeur*j]
            y_centre = y_centre + j*image_haut_data[i+largeur*j]
            somme = somme + image_haut_data[i+largeur*j]
    x_centre = 1.0*x_centre/somme
    y_centre = 1.0*y_centre/somme
    haut = [haut_haut_gauche_x + x_centre, haut_haut_gauche_y + y_centre]
    #print haut
    liste_haut.append(haut)

liste_rotation = []
fixe = len(liste_centre)/2

for i in range(len(liste_centre)):
    liste_rotation.append( atan( 1.0*( liste_haut[i][0]-liste_centre[i][0] )/( liste_haut[i][1]-liste_centre[i][1] ) )-atan( 1.0*( liste_haut[fixe][0]-liste_centre[fixe][0] )/( liste_haut[fixe][1]-liste_centre[fixe][1] ) ) )
#print liste_rotation

script1 = open('script-rotation.sh','w')
script2 = open('script-rotation-couleur.sh','w')
for i in range(len(liste_centre)):
    script1.write('echo '+liste_fichier[i]+'\n')
    script1.write('convert '+liste_fichier[i]+' -background black -affine '+str(cos(liste_rotation[i]))+','+str(sin(liste_rotation[i]))+','+str(-sin(liste_rotation[i]))+','+str(cos(liste_rotation[i]))+',0,0 -transform rot-'+liste_fichier[i]+'\n')
    script2.write('echo '+liste_fichier_couleur[i]+'\n')
    script2.write('convert '+liste_fichier_couleur[i]+' -background black -affine '+str(cos(liste_rotation[i]))+','+str(sin(liste_rotation[i]))+','+str(-sin(liste_rotation[i]))+','+str(cos(liste_rotation[i]))+',0,0 -transform rot-'+liste_fichier_couleur[i]+'\n')
script1.close()
script2.close()
print 'les scripts sont écrits'
    
